Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4671)
@@ -3454,4 +3257,24 @@
        n_surf = n_surf + surf_def_h(0)%ns
     ENDIF
+    IF ( ALLOCATED( var_lsm_h0 ) )  THEN
+       DO  m = 1, surf_lsm_h(0)%ns
+          n_surf                        = n_surf + 1
+          k                             = surf_lsm_h(0)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_lsm_h0(m) *        &
+                                          conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h0 ) )  THEN
+       DO  m = 1, surf_usm_h(0)%ns
+          n_surf                        = n_surf + 1
+          k                             = surf_usm_h(0)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_usm_h0(m) *          &
+                                          conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(0)%ns
+    ENDIF
     IF ( ALLOCATED( var_def_h1 ) )  THEN
        DO  m = 1, surf_def_h(1)%ns
@@ -3464,23 +3287,23 @@
        n_surf = n_surf + surf_def_h(1)%ns
     ENDIF
-    IF ( ALLOCATED( var_lsm_h ) )  THEN
-       DO  m = 1, surf_lsm_h%ns
+    IF ( ALLOCATED( var_lsm_h1 ) )  THEN
+       DO  m = 1, surf_lsm_h(1)%ns
           n_surf                        = n_surf + 1
-          k                             = surf_lsm_h%k(m)
-          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_lsm_h(m) *           &
+          k                             = surf_lsm_h(1)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_lsm_h1(m) *         &
                                           conversion_factor(k)
        ENDDO
     ELSE
-       n_surf = n_surf + surf_lsm_h%ns
-    ENDIF
-    IF ( ALLOCATED( var_usm_h ) )  THEN
-       DO  m = 1, surf_usm_h%ns
+       n_surf = n_surf + surf_lsm_h(1)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h1 ) )  THEN
+       DO  m = 1, surf_usm_h(1)%ns
           n_surf                        = n_surf + 1
-          k                             = surf_usm_h%k(m)
-          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_usm_h(m) *           &
+          k                             = surf_usm_h(1)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out) + var_usm_h1(m) *          &
                                           conversion_factor(k)
        ENDDO
     ELSE
-       n_surf = n_surf + surf_usm_h%ns
+       n_surf = n_surf + surf_usm_h(1)%ns
     ENDIF
 !
@@ -3621,9 +3444,11 @@
 !> approach.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE surface_data_output_sum_up_2d( var_def_h0, var_def_h1, var_lsm_h, var_usm_h,           &
-                                           var_def_v0, var_lsm_v0, var_usm_v0, var_def_v1,         &
-                                           var_lsm_v1, var_usm_v1, var_def_v2, var_lsm_v2,         &
-                                           var_usm_v2, var_def_v3, var_lsm_v3, var_usm_v3, n_out,  &
-                                           fac )
+ SUBROUTINE surface_data_output_sum_up_2d(  var_def_h0, var_lsm_h0, var_usm_h0,        &
+                                            var_def_h1, var_lsm_h1, var_usm_h1,        &
+                                            var_def_v0, var_lsm_v0, var_usm_v0,        &
+                                            var_def_v1, var_lsm_v1, var_usm_v1,        &
+                                            var_def_v2, var_lsm_v2, var_usm_v2,        &
+                                            var_def_v3, var_lsm_v3, var_usm_v3,        &
+                                            n_out, fac )
 
     IMPLICIT NONE
@@ -3638,7 +3463,9 @@
 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_h0  !< output variable at upward-facing default-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h0  !< output variable at upward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h0  !< output variable at upward-facing urban-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_h1  !< output variable at downward-facing default-type surfaces
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h   !< output variable at upward-facing natural-type surfaces
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h   !< output variable at upward-facing urban-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h1  !< output variable at downward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h1  !< output variable at downward-facing urban-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_v0  !< output variable at northward-facing default-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_v1  !< output variable at southward-facing default-type surfaces
@@ -3695,25 +3522,47 @@
        n_surf = n_surf + surf_def_h(1)%ns
     ENDIF
-    IF ( ALLOCATED( var_lsm_h ) )  THEN
-       DO  m = 1, surf_lsm_h%ns
+    IF ( ALLOCATED( var_lsm_h0 ) )  THEN
+       DO  m = 1, surf_lsm_h(0)%ns
           n_surf                        = n_surf + 1
-          k                             = surf_lsm_h%k(m)
+          k                             = surf_lsm_h(0)%k(m)
           surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out)                            &
-                                        + SUM ( surf_lsm_h%frac(m,:) *                             &
-                                          var_lsm_h(m,:) ) * conversion_factor(k)
-       ENDDO
-    ELSE
-       n_surf = n_surf + surf_lsm_h%ns
-    ENDIF
-    IF ( ALLOCATED( var_usm_h ) )  THEN
-       DO  m = 1, surf_usm_h%ns
+                                        + SUM ( surf_lsm_h(0)%frac(m,:) *                          &
+                                          var_lsm_h0(m,:) ) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_lsm_h1 ) )  THEN
+       DO  m = 1, surf_lsm_h(1)%ns
           n_surf                        = n_surf + 1
-          k                             = surf_usm_h%k(m)
+          k                             = surf_lsm_h(1)%k(m)
           surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out)                            &
-                                        + SUM ( surf_usm_h%frac(m,:) *                             &
-                                          var_usm_h(m,:) ) * conversion_factor(k)
-       ENDDO
-    ELSE
-       n_surf = n_surf + surf_usm_h%ns
+                                        + SUM ( surf_lsm_h(1)%frac(m,:) *                          &
+                                          var_lsm_h1(m,:) ) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(1)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h0 ) )  THEN
+       DO  m = 1, surf_usm_h(0)%ns
+          n_surf                        = n_surf + 1
+          k                             = surf_usm_h(0)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out)                            &
+                                        + SUM ( surf_usm_h(0)%frac(m,:) *                          &
+                                          var_usm_h0(m,:) ) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h1 ) )  THEN
+       DO  m = 1, surf_usm_h(1)%ns
+          n_surf                        = n_surf + 1
+          k                             = surf_usm_h(1)%k(m)
+          surfaces%var_av(n_surf,n_out) = surfaces%var_av(n_surf,n_out)                            &
+                                        + SUM ( surf_usm_h(1)%frac(m,:) *                          &
+                                          var_usm_h1(m,:) ) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(1)%ns
     ENDIF
 !
@@ -3865,8 +3714,10 @@
 !> Collect the surface data from different types and different orientation.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE surface_data_output_collect_1d( var_def_h0, var_def_h1, var_lsm_h, var_usm_h,          &
-                                           var_def_v0, var_lsm_v0, var_usm_v0, var_def_v1,         &
-                                           var_lsm_v1, var_usm_v1, var_def_v2, var_lsm_v2,         &
-                                           var_usm_v2, var_def_v3, var_lsm_v3, var_usm_v3, fac )
+ SUBROUTINE surface_data_output_collect_1d( var_def_h0, var_lsm_h0, var_usm_h0,        &
+                                            var_def_h1, var_lsm_h1, var_usm_h1,        &
+                                            var_def_v0, var_lsm_v0, var_usm_v0,        &
+                                            var_def_v1, var_lsm_v1, var_usm_v1,        &
+                                            var_def_v2, var_lsm_v2, var_usm_v2,        &
+                                            var_def_v3, var_lsm_v3, var_usm_v3, fac )
 
     IMPLICIT NONE
@@ -3881,6 +3732,8 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_def_h0  !< output variable at upward-facing default-type surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_def_h1  !< output variable at downward-facing default-type surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h   !< output variable at upward-facing natural-type surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_usm_h   !< output variable at upward-facing urban-type surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h0  !< output variable at upward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h1  !< output variable at downward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_usm_h0  !< output variable at upward-facing urban-type surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_usm_h1  !< output variable at downward-facing urban-type surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_def_v0  !< output variable at northward-facing default-type surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(IN) ::  var_def_v1  !< output variable at southward-facing default-type surfaces
@@ -3932,21 +3785,39 @@
        n_surf = n_surf + surf_def_h(1)%ns
     ENDIF
-    IF ( ALLOCATED( var_lsm_h ) )  THEN
-       DO  m = 1, surf_lsm_h%ns
+    IF ( ALLOCATED( var_lsm_h0 ) )  THEN
+       DO  m = 1, surf_lsm_h(0)%ns
           n_surf                   = n_surf + 1
-          k                        = surf_lsm_h%k(m)
-          surfaces%var_out(n_surf) = var_lsm_h(m) * conversion_factor(k)
-       ENDDO
-    ELSE
-       n_surf = n_surf + surf_lsm_h%ns
-    ENDIF
-    IF ( ALLOCATED( var_usm_h ) )  THEN
-       DO  m = 1, surf_usm_h%ns
+          k                        = surf_lsm_h(0)%k(m)
+          surfaces%var_out(n_surf) = var_lsm_h0(m) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_lsm_h1 ) )  THEN
+       DO  m = 1, surf_lsm_h(1)%ns
           n_surf                   = n_surf + 1
-          k                        = surf_usm_h%k(m)
-          surfaces%var_out(n_surf) = var_usm_h(m) * conversion_factor(k)
-       ENDDO
-    ELSE
-       n_surf = n_surf + surf_usm_h%ns
+          k                        = surf_lsm_h(1)%k(m)
+          surfaces%var_out(n_surf) = var_lsm_h1(m) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(1)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h0 ) )  THEN
+       DO  m = 1, surf_usm_h(0)%ns
+          n_surf                   = n_surf + 1
+          k                        = surf_usm_h(0)%k(m)
+          surfaces%var_out(n_surf) = var_usm_h0(m) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h1 ) )  THEN
+       DO  m = 1, surf_usm_h(1)%ns
+          n_surf                   = n_surf + 1
+          k                        = surf_usm_h(1)%k(m)
+          surfaces%var_out(n_surf) = var_usm_h1(m) * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(1)%ns
     ENDIF
 !
@@ -4075,8 +3946,10 @@
 !> defined using tile approach.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE surface_data_output_collect_2d( var_def_h0, var_def_h1, var_lsm_h, var_usm_h,          &
-                                            var_def_v0, var_lsm_v0, var_usm_v0, var_def_v1,        &
-                                            var_lsm_v1, var_usm_v1, var_def_v2, var_lsm_v2,        &
-                                            var_usm_v2, var_def_v3, var_lsm_v3, var_usm_v3, fac )
+ SUBROUTINE surface_data_output_collect_2d( var_def_h0, var_lsm_h0, var_usm_h0,       &
+                                            var_def_h1, var_lsm_h1, var_usm_h1,       &
+                                            var_def_v0, var_lsm_v0, var_usm_v0,       &
+                                            var_def_v1, var_lsm_v1, var_usm_v1,       &
+                                            var_def_v2, var_lsm_v2, var_usm_v2,       &
+                                            var_def_v3, var_lsm_v3, var_usm_v3, fac )
 
     IMPLICIT NONE
@@ -4091,6 +3964,8 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_h0  !< output variable at upward-facing default-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_h1  !< output variable at downward-facing default-type surfaces
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h   !< output variable at upward-facing natural-type surfaces
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h   !< output variable at upward-facing urban-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h0  !< output variable at upward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_lsm_h1  !< output variable at downward-facing natural-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h0  !< output variable at upward-facing urban-type surfaces
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_usm_h1  !< output variable at downward-facing urban-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_v0  !< output variable at northward-facing default-type surfaces
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, INTENT(IN) ::  var_def_v1  !< output variable at southward-facing default-type surfaces
@@ -4138,5 +4013,5 @@
           n_surf                   = n_surf + 1
           k                        = surf_def_h(1)%k(m)
-          surfaces%var_out(n_surf) = SUM ( surf_def_h(1)%frac(m,:) * var_def_h1(m,:) ) *           &
+          surfaces%var_out(n_surf) = SUM ( surf_def_h(1)%frac(m,:) * var_def_h1(m,:) ) *          &
                                      conversion_factor(k)
        ENDDO
@@ -4144,23 +4019,43 @@
        n_surf = n_surf + surf_def_h(1)%ns
     ENDIF
-    IF ( ALLOCATED( var_lsm_h ) )  THEN
-       DO  m = 1, surf_lsm_h%ns
+    IF ( ALLOCATED( var_lsm_h0 ) )  THEN
+       DO  m = 1, surf_lsm_h(0)%ns
           n_surf                   = n_surf + 1
-          k                        = surf_lsm_h%k(m)
-          surfaces%var_out(n_surf) = SUM ( surf_lsm_h%frac(m,:) * var_lsm_h(m,:) ) *               &
+          k                        = surf_lsm_h(0)%k(m)
+          surfaces%var_out(n_surf) = SUM ( surf_lsm_h(0)%frac(m,:) * var_lsm_h0(m,:) ) *          &
                                      conversion_factor(k)
        ENDDO
     ELSE
-       n_surf = n_surf + surf_lsm_h%ns
-    ENDIF
-    IF ( ALLOCATED( var_usm_h ) )  THEN
-       DO  m = 1, surf_usm_h%ns
+       n_surf = n_surf + surf_lsm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_lsm_h1 ) )  THEN
+       DO  m = 1, surf_lsm_h(1)%ns
           n_surf                   = n_surf + 1
-          k                        = surf_usm_h%k(m)
-          surfaces%var_out(n_surf) = SUM ( surf_usm_h%frac(m,:) * var_usm_h(m,:) )                 &
+          k                        = surf_lsm_h(1)%k(m)
+          surfaces%var_out(n_surf) = SUM ( surf_lsm_h(1)%frac(m,:) * var_lsm_h1(m,:) ) *         &
+                                     conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_lsm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h0 ) )  THEN
+       DO  m = 1, surf_usm_h(0)%ns
+          n_surf                   = n_surf + 1
+          k                        = surf_usm_h(0)%k(m)
+          surfaces%var_out(n_surf) = SUM ( surf_usm_h(0)%frac(m,:) * var_usm_h0(m,:) )            &
                                      * conversion_factor(k)
        ENDDO
     ELSE
-       n_surf = n_surf + surf_usm_h%ns
+       n_surf = n_surf + surf_usm_h(0)%ns
+    ENDIF
+    IF ( ALLOCATED( var_usm_h1 ) )  THEN
+       DO  m = 1, surf_usm_h(1)%ns
+          n_surf                   = n_surf + 1
+          k                        = surf_usm_h(1)%k(m)
+          surfaces%var_out(n_surf) = SUM ( surf_usm_h(1)%frac(m,:) * var_usm_h1(m,:) )            &
+                                     * conversion_factor(k)
+       ENDDO
+    ELSE
+       n_surf = n_surf + surf_usm_h(1)%ns
     ENDIF
 !
@@ -4723,18 +4618,18 @@
                 num_surf(j,i)         = num_surf(j,i) + 1
              ENDDO
-          ENDDO
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-             n                     = n + 1
-             surfaces%var_av(n,nv) = surf_in(start_index(j,i)+num_surf(j,i))
-             num_surf(j,i)         = num_surf(j,i) + 1
-          ENDDO
-          DO  m = 1, surf_usm_h%ns 
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
-             n                     = n + 1
-             surfaces%var_av(n,nv) = surf_in(start_index(j,i)+num_surf(j,i))
-             num_surf(j,i)         = num_surf(j,i) + 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+                n                     = n + 1
+                surfaces%var_av(n,nv) = surf_in(start_index(j,i)+num_surf(j,i))
+                num_surf(j,i)         = num_surf(j,i) + 1
+             ENDDO
+             DO  m = 1, surf_usm_h(l)%ns
+                i = surf_usm_h(l)%i(m)
+                j = surf_usm_h(l)%j(m)
+                n                     = n + 1
+                surfaces%var_av(n,nv) = surf_in(start_index(j,i)+num_surf(j,i))
+                num_surf(j,i)         = num_surf(j,i) + 1
+             ENDDO
           ENDDO
 
@@ -4857,14 +4752,14 @@
                 num_surf(j,i) = num_surf(j,i) + 1
              ENDDO
-          ENDDO
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-             num_surf(j,i) = num_surf(j,i) + 1
-          ENDDO
-          DO  m = 1, surf_usm_h%ns
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
-             num_surf(j,i) = num_surf(j,i) + 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+                num_surf(j,i) = num_surf(j,i) + 1
+             ENDDO
+             DO  m = 1, surf_usm_h(l)%ns
+                i = surf_usm_h(l)%i(m)
+                j = surf_usm_h(l)%j(m)
+                num_surf(j,i) = num_surf(j,i) + 1
+             ENDDO
           ENDDO
 
@@ -4915,18 +4810,18 @@
                    num_surf(j,i)                              = num_surf(j,i) + 1
                 ENDDO
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                n                                          = n + 1
-                surf_out(start_index(j,i)+num_surf(j,i)) = surfaces%var_av(n,nv)
-                num_surf(j,i)                              = num_surf(j,i) + 1
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                n                                          = n + 1
-                surf_out(start_index(j,i)+num_surf(j,i)) = surfaces%var_av(n,nv)
-                num_surf(j,i)                              = num_surf(j,i) + 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+                   n                                          = n + 1
+                   surf_out(start_index(j,i)+num_surf(j,i)) = surfaces%var_av(n,nv)
+                   num_surf(j,i)                              = num_surf(j,i) + 1
+                ENDDO
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   n                                          = n + 1
+                   surf_out(start_index(j,i)+num_surf(j,i)) = surfaces%var_av(n,nv)
+                   num_surf(j,i)                              = num_surf(j,i) + 1
+                ENDDO
              ENDDO
 
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4594 2020-07-09 15:01:00Z suehring
 ! Include k index in OMP PRIVATE statements
 !
@@ -285,13 +288,13 @@
           CALL calc_ln
        ENDIF
+       IF ( surf_lsm_h(l)%ns >= 1 )  THEN
+          surf => surf_lsm_h(l)
+          CALL calc_ln
+       ENDIF
+       IF ( surf_usm_h(l)%ns >= 1 )  THEN
+          surf => surf_usm_h(l)
+          CALL calc_ln
+       ENDIF
     ENDDO
-    IF ( surf_lsm_h%ns >= 1 )  THEN
-       surf => surf_lsm_h
-       CALL calc_ln
-    ENDIF
-    IF ( surf_usm_h%ns >= 1 )  THEN
-       surf => surf_usm_h
-       CALL calc_ln
-    ENDIF
 
     DO  l = 0, 3
@@ -311,6 +314,6 @@
 !
 !-- Derive potential temperature and specific humidity at first grid level from the fields pt and q
-!-- First call for horizontal default-type surfaces (l=0 - upward facing, l=1 - downward facing)
     DO  l = 0, 1
+!--    First call for horizontal default-type surfaces (l=0 - upward facing, l=1 - downward facing)
        IF ( surf_def_h(l)%ns >= 1  )  THEN
           surf => surf_def_h(l)
@@ -324,19 +327,17 @@
           ENDIF
        ENDIF
+!
+!--    Call for natural-type horizontal surfaces
+       IF ( surf_lsm_h(l)%ns >= 1  )  THEN
+          surf => surf_lsm_h(l)
+          CALL calc_pt_q
+       ENDIF
+!
+!--    Call for urban-type horizontal surfaces
+       IF ( surf_usm_h(l)%ns >= 1  )  THEN
+          surf => surf_usm_h(l)
+          CALL calc_pt_q
+       ENDIF
     ENDDO
-!
-!-- Call for natural-type horizontal surfaces
-    IF ( surf_lsm_h%ns >= 1  )  THEN
-       surf => surf_lsm_h
-       CALL calc_pt_q
-    ENDIF
-
-!
-!-- Call for urban-type horizontal surfaces
-    IF ( surf_usm_h%ns >= 1  )  THEN
-       surf => surf_usm_h
-       CALL calc_pt_q
-    ENDIF
-
 !
 !-- Call for natural-type vertical surfaces
@@ -373,6 +374,6 @@
 !
 !-- Natural-type horizontal surfaces
-    IF ( surf_lsm_h%ns >= 1 )  THEN
-       surf => surf_lsm_h
+    IF ( surf_lsm_h(0)%ns >= 1 )  THEN
+       surf => surf_lsm_h(0)
        CALL calc_uvw_abs
        IF ( .NOT. neutral )  CALL calc_ol
@@ -383,6 +384,6 @@
 !
 !-- Urban-type horizontal surfaces
-    IF ( surf_usm_h%ns >= 1 )  THEN
-       surf => surf_usm_h
+    IF ( surf_usm_h(0)%ns >= 1 )  THEN
+       surf => surf_usm_h(0)
        CALL calc_uvw_abs
        IF ( .NOT. neutral )  CALL calc_ol
@@ -396,15 +397,30 @@
 
 !
-!-- Treat downward-facing horizontal surfaces. Note, so far, these are always default type.
+!-- Treat downward-facing horizontal surfaces.
 !-- Stratification is not considered in this case, hence, no further distinction between different
 !-- most_method is required.
+    downward = .TRUE.
+!-- Default type.
     IF ( surf_def_h(1)%ns >= 1 )  THEN
-       downward = .TRUE.
        surf => surf_def_h(1)
        CALL calc_uvw_abs
        CALL calc_us
        CALL calc_surface_fluxes
-       downward = .FALSE.
-    ENDIF
+    ENDIF
+!-- Natural surface type.
+    IF ( surf_lsm_h(1)%ns >= 1 )  THEN
+       surf => surf_lsm_h(1)
+       CALL calc_uvw_abs
+       CALL calc_us
+       CALL calc_surface_fluxes
+    ENDIF
+!-- Urban surface type.
+    IF ( surf_usm_h(1)%ns >= 1 )  THEN
+       surf => surf_usm_h(1)
+       CALL calc_uvw_abs
+       CALL calc_us
+       CALL calc_surface_fluxes
+    ENDIF
+    downward = .FALSE.
 !
 !-- Calculate surfaces fluxes at vertical surfaces for momentum and subgrid-scale TKE. No stability
@@ -664,8 +680,12 @@
 !-- In case of runs with neutral statification, set Obukhov length to a large value
     IF ( neutral )  THEN
-       IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%ol = 1.0E10_wp
-       IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%ol    = 1.0E10_wp
-       IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%ol    = 1.0E10_wp
-
+       DO  l = 0, 1
+          IF ( surf_def_h(l)%ns >= 1  .AND.                                                        &
+               ALLOCATED( surf_def_h(l)%ol ) )  surf_def_h(l)%ol = 1.0E10_wp
+          IF ( surf_lsm_h(l)%ns    >= 1  .AND.                                                     &
+               ALLOCATED( surf_lsm_h(l)%ol ) )  surf_lsm_h(l)%ol = 1.0E10_wp
+          IF ( surf_usm_h(l)%ns    >= 1  .AND.                                                     &
+               ALLOCATED( surf_usm_h(l)%ol ) )  surf_usm_h(l)%ol = 1.0E10_wp
+       ENDDO
        DO  l = 0, 3
           IF ( surf_def_v(l)%ns >= 1  .AND.                                                        &
